;(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    define([], factory);
  } else if (typeof exports === 'object') {
    module.exports = factory();
  } else {
    root.Darkness = factory();
  }
}(this, function() {
var Darkness = (function() {
  var instance,
    element,
    body = document.querySelector('body');

  function createInstance() {
    createDarkness();
    return Darkness;
  }

  function createDarkness() {
    element = document.createElement('div');
    element.classList.add('c-darkness');
    body.appendChild(element);
  }

  return {
    body: body,
    isOpened: false,
    iCallThy: function iCallThy() {
      if (!instance) {
        instance = createInstance();
        this.itself = element;
        return instance;
      } else {
        throw 'Do not try to create more instances';
        return false;
      }
    },
    open: function open() {
      if (!this.isOpened) {
        this.topOffset = window.pageYOffset || document.documentElement.scrollTop;
        this.body.classList.add('darkness-has-come');
        this.body.style.top = -this.topOffset + 'px';
        this.isOpened = true;
      }
    },

    close: function close() {
      if (this.isOpened) {
        this.body.classList.remove('darkness-has-come');
        this.body.removeAttribute('style');
        window.scrollTo(0, this.topOffset);
        this.isOpened = false;
      }
    },
  };
})();

return Darkness;
}));
